#include "examples.h"

const int DIMENSIONS = 2;    // number of dimensions
const int ITERATIONS = 18;   // number of iterations
                             // keep ITERATIONS <= 18 for gnuplot to work properly
                             // keep ITERATIONS <= 20 for memory allocation

const double BOX_K = 1.0;    // size of initial box [-BOX_K, BOX_K]
const double MAX_TIME = 2.0; // maximum time value

const int doLog = 0;         // 0 means no log files; 1 means create log files
const int doPlot = 1;        // 0 means no log files; 1 means create log files

const int dim1 = 0; // first dimension for 3d plot, usually 0
const int dim2 = 1; // second dimension for 3d plot, usually 1
const double MIN_RES = 0.01; // small cubes are not visible in gnuplot

//char *equationName = "x' = x (-1 - x + 2 y), y' = y (2 + ? x + y); x(0) = -1, y(0) = -1";
char *equationName = "x' = (x - 1) (- x + 2 y - 2), y' = (y - 1) (x + y); x(0) = 0, y(0) = 0";

void computeDerivativeValue(int dim, mpfi_t v, mpfi_t x[DIMENSIONS]) {
	//mpfr_t c_;
	//mpfr_init(c_);
	//mpfr_set_d(c_, 0.01, GMP_RNDN);

	mpfi_t temp1;
	mpfi_init(temp1);

	switch (dim) {
	case 0:
		mpfi_sub_d(temp1, x[0], 1);
		mpfi_mul_d(v, x[1], 2);
		mpfi_sub(v, v, x[0]);
		mpfi_sub_d(v, v, 2);
		mpfi_mul(v, v, temp1);
		break;
	case 1:
		//mpfi_add(v, x[0], x[1]);
		//mpfi_add_d(v, v, 2);
		//mpfi_mul(v, v, x[1]);
		mpfi_sub_d(temp1, x[1], 1);
		mpfi_add(v, x[0], x[1]);
		mpfi_mul(v, v, temp1);
		break;
	}

	//mpfi_clear(temp1);

	//mpfr_clear(c_);
}
